=== debian/changelog ===
glfw3 (3.0.4-1) unstable; urgency=low

  * Initial release (Closes: #736330)

 -- Roman Valov <roman.valov@gmail.com>  Tue, 11 Feb 2014 22:48:48 +0100
