=== debian/control ===
Source: glfw3
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Mahyuddin Susanto <udienz@ubuntu.com>,
           Roman Valov <roman.valov@gmail.com>
Build-Depends: debhelper (>= 9), cmake,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libx11-dev, libxrandr-dev,
               libxi-dev, libxxf86vm-dev,
               libxext-dev, doxygen
Standards-Version: 3.9.5
Homepage: http://www.glfw.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/glfw3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/glfw3.git

Package: libglfw3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: portable library for OpenGL, window and input (libraries)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides shared libraries.

Package: libglfw3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libglfw3 (= ${binary:Version}), ${misc:Depends},
         mesa-common-dev, libglu1-mesa-dev | libglu-dev
Provides: libglfw-dev
Conflicts: libglfw-dev
Description: portable library for OpenGL, window and input (development files)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides development files.

Package: libglfw3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: portable library for OpenGL, window and input (documentation)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides documentation.
