=== debian/changelog ===
glfw3 (3.1.1-1) unstable; urgency=medium

  * New upstream version (Closes: #787320).

  * debian/control:
    - Drop 'Provides: libglfw-dev' from libglfw3-dev.
      - libglfw-dev refers only to the GLFW 2 API.
    - Add myself to the list of uploaders.
    - Bump standards version - no changes.
    - Use cgit Vcs-Browser URL.
    - Add new build dependencies for GLFW 3.1.
  * debian/copyright:
    - Updates for GLFW 3.1.
  * debian/patches:
    - Add patch to make the build reproducible (Closes: #790139).
  * debian/rules:
    - Enable parallel build.
    - Remove the override_dh_installdocs (it has no effect).
  * debian/watch:
    - Download upstream tarballs from the github repo instead of sourceforge.

 -- James Cowgill <james410@cowgill.org.uk>  Thu, 09 Jul 2015 10:20:25 +0100
