=== debian/control ===
--- 
+++ 
@@ -3,17 +3,25 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Mahyuddin Susanto <udienz@ubuntu.com>,
-           Roman Valov <roman.valov@gmail.com>
-Build-Depends: debhelper (>= 9), cmake,
-               libgl1-mesa-dev | libgl-dev,
-               libglu1-mesa-dev | libglu-dev,
-               libx11-dev, libxrandr-dev,
-               libxi-dev, libxxf86vm-dev,
-               libxext-dev, doxygen
-Standards-Version: 3.9.5
+           Roman Valov <roman.valov@gmail.com>,
+           James Cowgill <james410@cowgill.org.uk>
+Build-Depends:
+ cmake,
+ debhelper (>= 9),
+ doxygen,
+ libgl1-mesa-dev | libgl-dev,
+ libglu1-mesa-dev | libglu-dev,
+ libx11-dev,
+ libxcursor-dev,
+ libxext-dev,
+ libxi-dev,
+ libxinerama-dev,
+ libxrandr-dev,
+ libxxf86vm-dev
+Standards-Version: 3.9.6
 Homepage: http://www.glfw.org/
 Vcs-Git: git://anonscm.debian.org/pkg-games/glfw3.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/glfw3.git
+Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/glfw3.git
 
 Package: libglfw3
 Architecture: any
@@ -35,7 +43,6 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libglfw3 (= ${binary:Version}), ${misc:Depends},
          mesa-common-dev, libglu1-mesa-dev | libglu-dev
-Provides: libglfw-dev
 Conflicts: libglfw-dev
 Description: portable library for OpenGL, window and input (development files)
  GLFW is an Open Source, multi-platform library for creating
