=== debian/changelog ===
glfw3 (3.1.2-3) unstable; urgency=medium

  * debian/control:
    - Drop some obsolete build-dependencies.
    - Have libglfw3-dev depend on X11 libraries to fix the pkg-config file
      and the "build" autopkgtest.
    - Use secure Vcs-* URLs.
  * debian/tests:
    - Fix the "cmake" autopkgtest by depending on build-essential so that
      make is available.

 -- James Cowgill <james410@cowgill.org.uk>  Thu, 28 Jan 2016 14:45:22 +0000

glfw3 (3.1.2-2) unstable; urgency=medium

  * Fix and ship the cmake config files (Closes: #812853).
  * Added some autopkgtests to test if programs can be built using
    libglfw3-dev.

 -- James Cowgill <james410@cowgill.org.uk>  Wed, 27 Jan 2016 14:36:38 +0000

glfw3 (3.1.2-1) unstable; urgency=medium

  * New upstream version.

 -- James Cowgill <james410@cowgill.org.uk>  Mon, 12 Oct 2015 21:24:09 +0100
