=== debian/control ===
--- 
+++ 
@@ -10,18 +10,17 @@
  debhelper (>= 9),
  doxygen,
  libgl1-mesa-dev | libgl-dev,
- libglu1-mesa-dev | libglu-dev,
  libx11-dev,
  libxcursor-dev,
- libxext-dev,
  libxi-dev,
  libxinerama-dev,
  libxrandr-dev,
  libxxf86vm-dev
 Standards-Version: 3.9.6
 Homepage: http://www.glfw.org/
-Vcs-Git: git://anonscm.debian.org/pkg-games/glfw3.git
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/glfw3.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-games/glfw3.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/glfw3.git
+Testsuite: autopkgtest
 
 Package: libglfw3
 Architecture: any
@@ -41,8 +40,17 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libglfw3 (= ${binary:Version}), ${misc:Depends},
-         mesa-common-dev, libglu1-mesa-dev | libglu-dev
+Depends:
+ libglfw3 (= ${binary:Version}),
+ libgl1-mesa-dev | libgl-dev,
+ libglu1-mesa-dev | libglu-dev,
+ libx11-dev,
+ libxcursor-dev,
+ libxi-dev,
+ libxinerama-dev,
+ libxrandr-dev,
+ libxxf86vm-dev,
+ ${misc:Depends},
 Conflicts: libglfw-dev
 Description: portable library for OpenGL, window and input (development files)
  GLFW is an Open Source, multi-platform library for creating
