=== debian/tests/control ===
Tests: build
Depends: build-essential, libglfw3-dev, pkg-config

Tests: cmake
Depends: build-essential, cmake, libglfw3-dev
